(* compile unicode affixes *)
open Camomile

module MyRe = URe.Make(UText)
let r1 = Str.regexp " "

let compile_unicode_affixes file =
  let istr = open_in file in
  let (local_res: URe.regexp list ref) = ref [] in
  let rec loop () =
    let l = Str.split r1 (input_line istr) in
    let chars = List.map (fun cp -> UChar.chr_of_uint (int_of_string cp)) l in
      local_res := `String(chars) :: !local_res;
      loop () in
    try loop ()
    with End_of_file ->
      let final_reg = List.fold_left 
			(fun (c:URe.regexp) (x:URe.regexp) -> 
			   `Alt(x,c)) 
			(List.hd !local_res)
			(List.tl !local_res) in
	MyRe.compile final_reg
