(*
  Copyright The MITRE Corporation 2005.  All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

(** Some general scoring (and eventually error reporting) routines for labeled sequences *)

(** Takes two arrays of int arrays, [key] and [seq] and computes the per position accuracy *)
let seqs_accuracy (keys: int array array) (hyps: int array array) =
  let l1 = Array.length keys in
  let cor = ref 0 in
  let tot = ref 0 in
    assert (l1 == (Array.length hyps));
    for i = 0 to l1 - 1 do
      let k = keys.(i)
      and h = hyps.(i) in
      let l2 = Array.length k in
	assert (l2 == (Array.length h));
	for j = 0 to l2 - 1 do
	  if k.(j) = h.(j) then
	    incr cor;
	  incr tot
	done;
    done;
    (float_of_int !cor) /. (float_of_int !tot)
