module type COSTS =
  sig
	type t
	val min : t -> t -> t
	val sum : t -> t -> t
	val zero : t
  end

module type WORDS =
  sig
	module K:COSTS
	type t
	type letter
	val length : t -> int
	val get : t -> int -> letter
	val distance : letter option -> letter option -> K.t
  end

val string_dist : string -> string -> float
val string_dist_ops : string -> string -> (float * (string * char option * char option) list)
