(*
  Copyright The MITRE Corporation 2005.  All rights reserved.


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*)

module type ArraySig  =
  sig
    type t
    type arr
    val create : int -> arr
    val size_of : arr -> int
    val get : arr -> int -> t
    val set : arr -> int -> t -> unit
    val fill : arr -> t -> unit
    val make : int -> t -> arr
    val sub : arr -> int -> int -> arr
    val max : arr -> t
    val print : arr -> unit
  end

module type I_ArraySig = ArraySig with type t = int

module type F_ArraySig = ArraySig with type t = float

module FBigArrayImpl : F_ArraySig
module IBigArrayImpl : I_ArraySig
