(* script to convert data to SVM sequel sparse format *)

#use "topfind"
#require "maxeml"

let _ = Gc.set{(Gc.get()) with Gc.stack_limit = 100000000}

let negvl = "0" (* -1 *)

let _ =
  if (not ((Array.length Sys.argv) = 5)) then (
    Printf.printf "Usage: ocaml convert2SVMSequel.ml <train file> <test file> <svm format train> <svm format test>\n\n";
    exit 0 );
  let protos = GenMe.protoseqs_from_vectors Sys.argv.(1) in
  let test_protos = GenMe.protoseqs_from_vectors Sys.argv.(2) in
  let iset,fa,la = GenMe.get_inst_set ~runtime:false protos in
  let iset_t,_,_ = GenMe.get_inst_set ~runtime:true ~fa:(Some fa) ~la:(Some la) test_protos in
  let ilist = Array.of_list iset.Instance.r_insts
  and ilist_t = Array.of_list iset_t.Instance.r_insts in
  let ostr1 = open_out Sys.argv.(3) in
  let ostr2 = open_out Sys.argv.(4) in
  let binary = (la.Instance.size = 2) in
  let print_em ostr ilist =
    Array.iter 
      (fun ri ->
	 let l = Instance.get_label ri
	 and fv = Instance.get_f_vector ri in
	 let al = if binary then (if l = 0 then negvl else "1") else (string_of_int (l+1)) in
	   Printf.fprintf ostr "%s" al;
	   let inds = Array.to_list (Vectors.get_indices fv) in
	   let vals = Array.to_list (Vectors.get_values fv) in
	   let iv_pairs = List.combine inds vals in
	   let sorted = List.sort (fun (i,v) (ii,vv) -> i - ii) iv_pairs in
	     List.iter
	       (fun (i,v) ->
		  Printf.fprintf ostr " %d:%f" (i + 1) v ) sorted;
	     Printf.fprintf ostr "\n") ilist;
    close_out ostr in
    print_em ostr1 ilist;
    print_em ostr2 ilist_t;
    Hashtbl.iter
      (fun k v ->
	 Printf.printf "%d\t%s\n" v k) la.Instance.map
