(*
  Copyright The MITRE Corporation 2005.  All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

(** Feature Induction **)

(** Function Value Induction - simply select those features that reduce the function
    value the most in a short number of steps - these will be the ones with the steepest
    gradient generally **)

(* Algorithm outline:
1   - K = 0
2   - Gather all the remaining atomic features
3   - Select some set of candidates from atomics (ones with highest gain or frequency)
4   - Form conjunctions out of candidates
5   - Select the top N conjunctions (by gain) and atomic features to add, K = K + N
6   - Goto 2
