
#use "topfind"
#require "maxeml"

let print_model_details umodel ofile =
  let ostr = open_out ofile in
  let inv_fa_map = (Instance.invert_alphabet umodel.Maxent.um_falpha).Instance.inv_map in
  let inv_la_map = (Instance.invert_alphabet umodel.Maxent.um_lalpha).Instance.inv_map in
  let model = umodel.Maxent.um_model in
  let p = model.Maxent.parameters in
    Printf.printf "\n Number of features: %d\n" model.Maxent.nfs;
    Printf.printf "\n F-size: %d\n" umodel.Maxent.um_falpha.Instance.size;
    for i = 0 to (model.Maxent.nfs * model.Maxent.nls) - 1 do
      let fid = i mod model.Maxent.nfs - 1 in
      let lid = i / model.Maxent.nfs in
	if fid >= 0 then 
	  Printf.fprintf ostr "%f\t%s:(%s)\n" p.{i} (Hashtbl.find inv_fa_map fid) 
	    (Hashtbl.find inv_la_map lid);
    done; close_out ostr

let get_model model_file = 
  let in_ch = open_in model_file in
  let (model:Maxent.user_model) = Marshal.from_channel in_ch in
  close_in in_ch;
  model

let _ = let m = get_model Sys.argv.(1) in print_model_details m Sys.argv.(2)
