(*
  Copyright The MITRE Corporation 2005.  All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*)


module type OptSig =
  sig
    type ibarray = (int, Bigarray.int_elt, Bigarray.c_layout) Bigarray.Array1.t
    type rbarray = (float, Bigarray.float64_elt, Bigarray.c_layout) Bigarray.Array1.t

    module type McsrchSig = 
      sig
	val init : unit -> unit
	val mcsrch : int -> rbarray -> float ref -> rbarray -> rbarray
	  -> int -> float ref -> float -> float -> int -> int ref -> int ref -> rbarray -> unit
      end
    module Mcsrch : McsrchSig
    module type LbfgsSig = 
      sig
	val init : unit -> unit
	val lbfgs : int -> int -> rbarray -> float ref -> rbarray -> bool ref -> rbarray -> int array
	  -> float -> float -> int ref -> unit
      end
    module type TestSig =
      sig
	val test : unit -> unit
      end
    module Test : TestSig
    module Lbfgs : LbfgsSig
  end

module Opt : OptSig

