(*
  Copyright The MITRE Corporation 2005.  All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*)

type rbarray = (float, Bigarray.float64_elt, Bigarray.c_layout) Bigarray.Array1.t
type sparse_vector = {size: int;
		      indices: int array;
		      values: float array}
type dense_vector = rbarray

val get_indices : sparse_vector -> int array
val get_values : sparse_vector -> float array      
val plus_equals_m : float -> int -> int -> dense_vector -> dense_vector -> unit
val plus_equals : float -> int -> int -> sparse_vector -> dense_vector -> unit
val times_equals : float -> int -> int -> dense_vector -> unit
val print_sp_vec : sparse_vector -> unit
val ds_dot_product : int -> rbarray -> sparse_vector -> float
val create : int array -> float array -> sparse_vector
val l_create : int list -> float list -> sparse_vector
val sp_dot_product : sparse_vector -> sparse_vector -> float

